export interface IState {
}
export interface IAction<TState extends IState> {
    execute(state: TState): void;
}
export interface IAsyncAction<TState extends IState> {
    execute(state: TState, resolve: (value?: TState) => void, reject: (errors?: any) => void): void;
}
export interface IStore<TState extends IState> {
    dispatch(action: IAction<TState> | ((state: TState) => TState)): TState;
    dispatchAsync(action: IAsyncAction<TState> | ((state: TState, resolve: (value?: TState) => void, reject: (errors?: any) => void) => void)): Promise<IState>;
    getState(): TState;
}
