import * as Promise from "bluebird";
import { IState, IAction, IAsyncAction, IStore } from "./";
import { IStateListener, IStateNotifier } from "./../observer";
export declare class Store<TState extends IState> implements IStore<TState>, IStateNotifier {
    private state;
    private notifier;
    private cloneState(state?);
    private updateState(state);
    constructor(initialState: TState);
    dispatch(action: IAction<TState> | ((state: TState) => TState)): TState;
    dispatchAsync(action: IAsyncAction<TState> | ((state: TState, resolve: (value?: TState) => void, reject: (errors?: any) => void) => void)): Promise<TState>;
    getState(): TState;
    subscribe(listener: IStateListener): void;
}
